
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 12.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "kaiser.vec"
	.INCLUDE "kaiser.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.9 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : kaiser
;       9 Version :
;      10 Date    : 26.01.2010
;      11 Author  : noname
;      12 Company : none
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 12.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega16.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      28 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      32 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 
;      37 #include <delay.h>
;      38 //#include <math.h>
;      39 
;      40 #define ADC_VREF_TYPE 0x00
;      41 
;      42 
;      43 const unsigned char ind_arr[21] = {   // 

	.CSEG
;      44     0xFC, 0x60, 0xDA, 0xF2, 0x66, 0xB6, 0xBE, 0xE0, 0xFE, 0xF6, //0123456789
;      45     0x02, 0xC6, 0x9E, 0x8E, 0x2A, 0x0A, 0x7A, 0x6E, 0x0C, 0x1E, //-EFnrdHIt
;      46     0x00 //
;      47     };
;      48 
;      49 const unsigned char tmr_time_first = 100; //      
;      50 const unsigned char pwr_time_first = 100; //      
;      51 const unsigned char set_time_first = 100; //      
;      52 const unsigned char snd_time_key = 3;     //   
;      53 const unsigned char snd_time_tmr = 10;     //  
;      54 const unsigned char count_key_pressed_first = 10; //    
;      55 const unsigned char count_key_released_first = 20; //    
;      56 
;      57 bit bit_sec_1; //1 -     , 0 - 
;      58 bit pwr_on; //1 -  , 0 - 
;      59 bit tmr_on; //1 -  , 0 - 
;      60 bit tmr_ind; //1 -   
;      61 bit set_hour; //1 -   
;      62 bit set_min; //1 -   
;      63 bit err_5v, err_12v; //1 -    ( )
;      64 
;      65 unsigned int adc_0, adc_1, adc_2; //  ADC - ,  5  12
;      66 unsigned int pwr_mod; //  , 0 - 
;      67 unsigned int pwr_rly; //  
;      68 unsigned int key_in, key_tmp, key_ok, key_old; //    

	.DSEG
_key_in:
	.BYTE 0x2
_key_tmp:
	.BYTE 0x2
_key_ok:
	.BYTE 0x2
_key_old:
	.BYTE 0x2
;      69 unsigned char count_key_pressed, count_key_released; //  
_count_key_pressed:
	.BYTE 0x1
_count_key_released:
	.BYTE 0x1
;      70 unsigned char tmr_time; //   
_tmr_time:
	.BYTE 0x1
;      71 unsigned char pwr_time; //     
_pwr_time:
	.BYTE 0x1
;      72 unsigned char set_time; //   
_set_time:
	.BYTE 0x1
;      73 unsigned char snd_time; //   
_snd_time:
	.BYTE 0x1
;      74 unsigned char snd_num; //   
_snd_num:
	.BYTE 0x1
;      75 unsigned char tmp_1, tmp_2; //temporary
_tmp_1:
	.BYTE 0x1
_tmp_2:
	.BYTE 0x1
;      76 unsigned char n25, n15; //   1
_n25:
	.BYTE 0x1
_n15:
	.BYTE 0x1
;      77 unsigned char n4 = 3; //    , 0 -  
_n4:
	.BYTE 0x1
;      78 unsigned char hour, min, sec; //   
_hour:
	.BYTE 0x1
_min:
	.BYTE 0x1
_sec:
	.BYTE 0x1
;      79 unsigned char hsec; //   
_hsec:
	.BYTE 0x1
;      80 unsigned char tmr_min, tmr_sec; ////  
_tmr_min:
	.BYTE 0x1
_tmr_sec:
	.BYTE 0x1
;      81 unsigned char hour_h, hour_l, min_h, min_l; //   
_hour_h:
	.BYTE 0x1
_hour_l:
	.BYTE 0x1
_min_h:
	.BYTE 0x1
_min_l:
	.BYTE 0x1
;      82 
;      83 unsigned char adc_arr[4] = {16, 16, 18, 17};  //   
_adc_arr:
	.BYTE 0x4
;      84 
;      85 
;      86 /******************    ******************/
;      87 
;      88 
;      89 
;      90 // Read the AD conversion result
;      91 unsigned int read_adc(unsigned char adc_input)
;      92 {

	.CSEG
_read_adc:
;      93 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
;      94 // Delay needed for the stabilization of the ADC input voltage
;      95 delay_us(10);
	__DELAY_USB 40
;      96 // Start the AD conversion
;      97 ADCSRA|=0x40;
	SBI  0x6,6
;      98 // Wait for the AD conversion to complete
;      99 while ((ADCSRA & 0x10)==0);
_0x5:
	SBIS 0x6,4
	RJMP _0x5
;     100 ADCSRA|=0x10;
	SBI  0x6,4
;     101 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
;     102 }
;     103 
;     104 
;     105 
;     106 //      164
;     107 void reg164(unsigned char rezh, unsigned char xx, unsigned char simb, unsigned char dp)
;     108 {
_reg164:
;     109 unsigned char x;
;     110 if (rezh) simb = ind_arr[simb] + dp; // rezh=1    ,   
	ST   -Y,R17
;	rezh -> Y+4
;	xx -> Y+3
;	simb -> Y+2
;	dp -> Y+1
;	x -> R17
	LDD  R30,Y+4
	CPI  R30,0
	BREQ _0x8
	LDD  R30,Y+2
	LDI  R31,0
	SUBI R30,LOW(-_ind_arr*2)
	SBCI R31,HIGH(-_ind_arr*2)
	LPM  R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	STD  Y+2,R30
;     111 for (x = 0; x < xx; x ++) // 
_0x8:
	LDI  R17,LOW(0)
_0xA:
	LDD  R30,Y+3
	CP   R17,R30
	BRSH _0xB
;     112     {
;     113     PORTC.6 = simb % 2;
	LDD  R30,Y+2
	ANDI R30,LOW(0x1)
	BRNE _0xC
	CBI  0x15,6
	RJMP _0xD
_0xC:
	SBI  0x15,6
_0xD:
;     114     simb >>= 1;
	LDD  R30,Y+2
	LSR  R30
	STD  Y+2,R30
;     115     PORTC.5 = 1;
	SBI  0x15,5
;     116     delay_us(1);
	__DELAY_USB 4
;     117     PORTC.5 = 0;
	CBI  0x15,5
;     118     }
	SUBI R17,-1
	RJMP _0xA
_0xB:
;     119 }
	LDD  R17,Y+0
	ADIW R28,5
	RET
;     120 
;     121 
;     122 
;     123 //  2-10  ADC
;     124 void _2_10(unsigned int xx)
;     125 {
__2_10:
;     126 adc_arr[0] = xx % 10;
;	xx -> Y+0
	RCALL SUBOPT_0x0
	CALL __MODW21U
	STS  _adc_arr,R30
;     127 xx = xx / 10;
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
;     128 adc_arr[1] = xx % 10;
	CALL __MODW21U
	__PUTB1MN _adc_arr,1
;     129 xx = xx / 10;
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
;     130 adc_arr[2] = xx % 10;
	CALL __MODW21U
	__PUTB1MN _adc_arr,2
;     131 adc_arr[3] = xx / 10;
	RCALL SUBOPT_0x0
	CALL __DIVW21U
	__PUTB1MN _adc_arr,3
;     132 }
	ADIW R28,2
	RET
;     133 
;     134 
;     135 
;     136 //    
;     137 void pwr_pp(void)
;     138 {
_pwr_pp:
;     139 if (pwr_time == 0) return;
	LDS  R30,_pwr_time
	CPI  R30,0
	BRNE _0x12
	RET
;     140 if (pwr_time == 1)
_0x12:
	LDS  R26,_pwr_time
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x13
;     141     {
;     142     PORTB.4 = 1;         //  
	SBI  0x18,4
;     143     switch (pwr_mod)     // 
	MOVW R30,R10
;     144         {
;     145         case 1: pwr_rly = 80; break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x19
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	MOVW R12,R30
	RJMP _0x18
;     146         case 2: pwr_rly = 102; break;
_0x19:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x1A
	LDI  R30,LOW(102)
	LDI  R31,HIGH(102)
	MOVW R12,R30
	RJMP _0x18
;     147         case 4: pwr_rly = 34; break;
_0x1A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x1B
	LDI  R30,LOW(34)
	LDI  R31,HIGH(34)
	MOVW R12,R30
	RJMP _0x18
;     148         case 8: pwr_rly = 38; break;
_0x1B:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x1C
	LDI  R30,LOW(38)
	LDI  R31,HIGH(38)
	MOVW R12,R30
	RJMP _0x18
;     149         case 16: pwr_rly = 67; break;
_0x1C:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x1D
	LDI  R30,LOW(67)
	LDI  R31,HIGH(67)
	MOVW R12,R30
	RJMP _0x18
;     150         case 32: pwr_rly = 81; break;
_0x1D:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x1E
	LDI  R30,LOW(81)
	LDI  R31,HIGH(81)
	MOVW R12,R30
	RJMP _0x18
;     151         case 64: pwr_rly = 80; break;
_0x1E:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x1F
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	MOVW R12,R30
	RJMP _0x18
;     152         case 128: pwr_rly = 3; break;
_0x1F:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x20
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	MOVW R12,R30
	RJMP _0x18
;     153         case 256: pwr_rly = 1; break;
_0x20:
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRNE _0x21
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	MOVW R12,R30
	RJMP _0x18
;     154         case 512: pwr_rly = 128; break;
_0x21:
	CPI  R30,LOW(0x200)
	LDI  R26,HIGH(0x200)
	CPC  R31,R26
	BRNE _0x23
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	MOVW R12,R30
	RJMP _0x18
;     155         default: pwr_rly = 0; PORTB.4 = 0; // ,  
_0x23:
	CLR  R12
	CLR  R13
	CBI  0x18,4
;     156             snd_time = snd_time_tmr;       //   
	LDI  R30,LOW(_snd_time_tmr*2)
	LDI  R31,HIGH(_snd_time_tmr*2)
	LPM  R30,Z
	STS  _snd_time,R30
;     157         }
_0x18:
;     158     pwr_time = 0;
	LDI  R30,LOW(0)
	STS  _pwr_time,R30
;     159     PORTD = pwr_rly;     //  
	MOVW R30,R12
	OUT  0x12,R30
;     160     }
;     161 else pwr_time --;
	RJMP _0x26
_0x13:
	LDS  R30,_pwr_time
	SUBI R30,LOW(1)
	STS  _pwr_time,R30
;     162 }
_0x26:
	RET
;     163 
;     164 
;     165 
;     166 //   
;     167 void tmr_pp(void)
;     168 {
_tmr_pp:
;     169 if (tmr_time == 0) return;
	LDS  R30,_tmr_time
	CPI  R30,0
	BRNE _0x27
	RET
;     170 if (tmr_time == 1)
_0x27:
	LDS  R26,_tmr_time
	CPI  R26,LOW(0x1)
	BRNE _0x28
;     171     {
;     172     if (tmr_min > 0) tmr_on = 1; //    ,   
	LDS  R26,_tmr_min
	CPI  R26,LOW(0x1)
	BRLO _0x29
	SET
	BLD  R2,2
;     173     tmr_ind = 0;
_0x29:
	CLT
	BLD  R2,3
;     174     tmr_sec = 0;
	LDI  R30,LOW(0)
	STS  _tmr_sec,R30
;     175     tmr_time = 0;
	RJMP _0xCB
;     176     }
;     177 else tmr_time --;
_0x28:
	LDS  R30,_tmr_time
	SUBI R30,LOW(1)
_0xCB:
	STS  _tmr_time,R30
;     178 }
	RET
;     179 
;     180 
;     181 
;     182 //   ..
;     183 void set_pp(void)
;     184 {
_set_pp:
;     185 if (set_time == 0) return;
	LDS  R30,_set_time
	CPI  R30,0
	BRNE _0x2B
	RET
;     186 if (set_time == 1)
_0x2B:
	LDS  R26,_set_time
	CPI  R26,LOW(0x1)
	BRNE _0x2C
;     187     {
;     188     set_time = 0;
	LDI  R30,LOW(0)
	STS  _set_time,R30
;     189     set_hour = 0;
	CLT
	BLD  R2,4
;     190     set_min = 0;
	BLD  R2,5
;     191     }
;     192 else set_time --;
	RJMP _0x2D
_0x2C:
	LDS  R30,_set_time
	SUBI R30,LOW(1)
	STS  _set_time,R30
;     193 }
_0x2D:
	RET
;     194 
;     195 
;     196 
;     197 //   
;     198 void snd_pp(void)
;     199 {
_snd_pp:
;     200 if (snd_time == 0) return;
	LDS  R30,_snd_time
	CPI  R30,0
	BRNE _0x2E
	RET
;     201 if (snd_time == 1)
_0x2E:
	LDS  R26,_snd_time
	CPI  R26,LOW(0x1)
	BRNE _0x2F
;     202     {
;     203     snd_time = 0;
	LDI  R30,LOW(0)
	STS  _snd_time,R30
;     204     if (snd_num > 0) snd_num --; //   ,   
	LDS  R26,_snd_num
	CPI  R26,LOW(0x1)
	BRLO _0x30
	LDS  R30,_snd_num
	SUBI R30,LOW(1)
	STS  _snd_num,R30
;     205     PORTB.0 = 0;
_0x30:
	CBI  0x18,0
;     206     }
;     207 else snd_time --;
	RJMP _0x33
_0x2F:
	LDS  R30,_snd_time
	SUBI R30,LOW(1)
	STS  _snd_time,R30
;     208 }
_0x33:
	RET
;     209 
;     210 
;     211 
;     212 /******************    ******************/
;     213 
;     214 
;     215 
;     216 // External Interrupt 1 service routine -     .
;     217 interrupt [EXT_INT1] void ext_int1_isr(void)
;     218 {
_ext_int1_isr:
;     219 // Place your code here
;     220 
;     221 }
	RETI
;     222 
;     223 
;     224 
;     225 // Timer 1 output compare A interrupt service routine -  
;     226 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;     227 {
_timer1_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     228 // Place your code here
;     229 if (snd_time == 0) return;  //     
	LDS  R30,_snd_time
	CPI  R30,0
	BREQ _0xE2
;     230 PORTB.0 = ~PORTB.0;
	SBIS 0x18,0
	RJMP _0x35
	CBI  0x18,0
	RJMP _0x36
_0x35:
	SBI  0x18,0
_0x36:
;     231 }
_0xE2:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     232 
;     233 
;     234 
;     235 // Timer 0 output compare interrupt service routine - 375   ..  
;     236 interrupt [TIM0_COMP] void timer0_comp_isr(void)
;     237 {
_timer0_comp_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     238 //   ,   164
;     239 PORTC = 0;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     240 delay_us(1);
	__DELAY_USB 4
;     241 PORTC.4 = 1;
	SBI  0x15,4
;     242 if (hsec > 62)  //  375  !!!!!   . 4, -   125
	LDS  R26,_hsec
	CPI  R26,LOW(0x3F)
	BRLO _0x39
;     243     bit_sec_1 = 0;   // 1 
	CLT
	BLD  R2,0
;     244 else
	RJMP _0x3A
_0x39:
;     245     hsec ++;
	LDS  R30,_hsec
	SUBI R30,-LOW(1)
	STS  _hsec,R30
;     246 
;     247 adc_0 = read_adc(0); //  
_0x3A:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R4,R30
;     248 adc_1 = read_adc(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _read_adc
	MOVW R6,R30
;     249 
;     250 //  - 1525=375  !!!!!   . 4, - 525=125
;     251 if (n15 < 4)  //14
	LDS  R26,_n15
	CPI  R26,LOW(0x4)
	BRSH _0x3B
;     252     n15 ++;
	LDS  R30,_n15
	SUBI R30,-LOW(1)
	STS  _n15,R30
;     253 else
	RJMP _0x3C
_0x3B:
;     254     {
;     255     n15 = 0;
	LDI  R30,LOW(0)
	STS  _n15,R30
;     256     pwr_pp(); //  
	RCALL _pwr_pp
;     257     tmr_pp(); //  
	RCALL _tmr_pp
;     258     set_pp(); //  ..
	RCALL _set_pp
;     259     snd_pp(); // 
	RCALL _snd_pp
;     260     if (n25 < 24)
	LDS  R26,_n25
	CPI  R26,LOW(0x18)
	BRSH _0x3D
;     261         {
;     262         n25 ++;
	LDS  R30,_n25
	SUBI R30,-LOW(1)
	STS  _n25,R30
;     263         adc_2 = adc_2 + read_adc(2);  //  2  ADC - 
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _read_adc
	__ADDWRR 8,9,30,31
;     264         }
;     265     else
	RJMP _0x3E
_0x3D:
;     266         {
;     267         n25 = 0;
	LDI  R30,LOW(0)
	STS  _n25,R30
;     268         bit_sec_1 = 1; // 1   
	SET
	BLD  R2,0
;     269         hsec = 0;
	STS  _hsec,R30
;     270 
;     271         //2  ADC
;     272         adc_2 = adc_2 / 24;  //    24  \
	MOVW R26,R8
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CALL __DIVW21U
	MOVW R8,R30
;     273         if (err_5v)          //   
	SBRS R2,6
	RJMP _0x3F
;     274             _2_10(adc_0);    //  
	ST   -Y,R5
	ST   -Y,R4
	RJMP _0xCC
;     275         else
_0x3F:
;     276             if (err_12v)
	SBRS R2,7
	RJMP _0x41
;     277                 _2_10(adc_1);
	ST   -Y,R7
	ST   -Y,R6
	RJMP _0xCC
;     278             else
_0x41:
;     279                 _2_10(adc_2);
	ST   -Y,R9
	ST   -Y,R8
_0xCC:
	RCALL __2_10
;     280         adc_2 = 0;
	CLR  R8
	CLR  R9
;     281 
;     282         //
;     283         if (sec < 59)
	LDS  R26,_sec
	CPI  R26,LOW(0x3B)
	BRSH _0x43
;     284             sec ++;
	LDS  R30,_sec
	SUBI R30,-LOW(1)
	RJMP _0xCD
;     285         else
_0x43:
;     286             {
;     287             if (min < 59)
	LDS  R26,_min
	CPI  R26,LOW(0x3B)
	BRSH _0x45
;     288                 min ++;
	LDS  R30,_min
	SUBI R30,-LOW(1)
	RJMP _0xCE
;     289             else
_0x45:
;     290                 {
;     291                 if (hour < 23)
	LDS  R26,_hour
	CPI  R26,LOW(0x17)
	BRSH _0x47
;     292                     hour ++;
	LDS  R30,_hour
	SUBI R30,-LOW(1)
	RJMP _0xCF
;     293                 else
_0x47:
;     294                     hour = 0;
	LDI  R30,LOW(0)
_0xCF:
	STS  _hour,R30
;     295                 min = 0;
	LDI  R30,LOW(0)
_0xCE:
	STS  _min,R30
;     296                 }
;     297             sec = 0;
	LDI  R30,LOW(0)
_0xCD:
	STS  _sec,R30
;     298             }
;     299 
;     300         //
;     301         if (tmr_on && ~tmr_ind)
	SBRS R2,2
	RJMP _0x4A
	SBRS R2,3
	RJMP _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
;     302             {
;     303             if (tmr_sec < 59)
	LDS  R26,_tmr_sec
	CPI  R26,LOW(0x3B)
	BRSH _0x4C
;     304                 tmr_sec ++;
	LDS  R30,_tmr_sec
	SUBI R30,-LOW(1)
	RJMP _0xD0
;     305             else
_0x4C:
;     306                 {
;     307                 if (tmr_min > 1)
	LDS  R26,_tmr_min
	CPI  R26,LOW(0x2)
	BRLO _0x4E
;     308                     tmr_min --;
	LDS  R30,_tmr_min
	SUBI R30,LOW(1)
	STS  _tmr_min,R30
;     309                 else
	RJMP _0x4F
_0x4E:
;     310                     {
;     311                     tmr_on = 0;
	CLT
	BLD  R2,2
;     312                     tmr_min = 0;
	LDI  R30,LOW(0)
	STS  _tmr_min,R30
;     313                     snd_num = 60; // 60  
	LDI  R30,LOW(60)
	STS  _snd_num,R30
;     314                     }
_0x4F:
;     315                 tmr_sec = 0;
	LDI  R30,LOW(0)
_0xD0:
	STS  _tmr_sec,R30
;     316                 }
;     317             }
;     318 
;     319         //  
;     320         if (snd_num > 0)
_0x49:
	LDS  R26,_snd_num
	CPI  R26,LOW(0x1)
	BRLO _0x50
;     321             {
;     322             snd_time = snd_time_tmr;
	LDI  R30,LOW(_snd_time_tmr*2)
	LDI  R31,HIGH(_snd_time_tmr*2)
	LPM  R30,Z
	STS  _snd_time,R30
;     323             }
;     324 
;     325         //   
;     326         if (tmr_ind)
_0x50:
	SBRS R2,3
	RJMP _0x51
;     327             {
;     328             min_l = tmr_min % 10;
	LDS  R26,_tmr_min
	LDI  R30,LOW(10)
	CALL __MODB21U
	STS  _min_l,R30
;     329             min_h = tmr_min / 10;
	LDS  R26,_tmr_min
	LDI  R30,LOW(10)
	CALL __DIVB21U
	STS  _min_h,R30
;     330             hour_l = 20;//  
	LDI  R30,LOW(20)
	STS  _hour_l,R30
;     331             hour_h = 20; //20 -  ""
	RJMP _0xD1
;     332             }
;     333         else
_0x51:
;     334             {
;     335             min_l = min % 10;
	LDS  R26,_min
	LDI  R30,LOW(10)
	CALL __MODB21U
	STS  _min_l,R30
;     336             min_h = min / 10;
	LDS  R26,_min
	LDI  R30,LOW(10)
	CALL __DIVB21U
	STS  _min_h,R30
;     337             hour_l = hour % 10;
	LDS  R26,_hour
	LDI  R30,LOW(10)
	CALL __MODB21U
	STS  _hour_l,R30
;     338             if (hour > 9) //  
	LDS  R26,_hour
	CPI  R26,LOW(0xA)
	BRLO _0x53
;     339                 hour_h = hour / 10;
	LDI  R30,LOW(10)
	CALL __DIVB21U
	RJMP _0xD2
;     340             else
_0x53:
;     341                 hour_h = 20; //20 -  ""
_0xD1:
	LDI  R30,LOW(20)
_0xD2:
	STS  _hour_h,R30
;     342             }
;     343         } //if (n25 < 24)
_0x3E:
;     344     }//if (n15 < 14)   - 1525=375
_0x3C:
;     345 
;     346 //  
;     347 if (n4 < 3)
	LDS  R26,_n4
	CPI  R26,LOW(0x3)
	BRSH _0x55
;     348     n4 ++;
	LDS  R30,_n4
	SUBI R30,-LOW(1)
	RJMP _0xD3
;     349 else
_0x55:
;     350     n4 = 0;
	LDI  R30,LOW(0)
_0xD3:
	STS  _n4,R30
;     351 
;     352 
;     353 //    
;     354 tmp_2 = 0;
	RCALL SUBOPT_0x2
;     355 switch (n4)
;     356     {
;     357     case 0: tmp_1 = pwr_mod; break;
	BRNE _0x5A
	MOVW R30,R10
	RJMP _0xD4
;     358     case 1: tmp_1 = pwr_mod >> 5; break;
_0x5A:
	CPI  R30,LOW(0x1)
	BREQ _0xD5
;     359     case 2: tmp_1 = pwr_mod; break;
	CPI  R30,LOW(0x2)
	BRNE _0x5C
	MOVW R30,R10
	RJMP _0xD4
;     360     case 3: tmp_1 = pwr_mod >> 5;
_0x5C:
	CPI  R30,LOW(0x3)
	BRNE _0x59
_0xD5:
	MOVW R26,R10
	LDI  R30,LOW(5)
	CALL __LSRW12
_0xD4:
	STS  _tmp_1,R30
;     361     }
_0x59:
;     362 reg164(0, 5, tmp_1, tmp_2);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x3
;     363 
;     364 
;     365 //     
;     366 tmp_2 = 0;
	RCALL SUBOPT_0x2
;     367 switch (n4)
;     368     {
;     369     case 0: if (set_min && ~bit_sec_1) tmp_1 = 20; else tmp_1 = min_l; //    ..
	BRNE _0x61
	SBRS R2,5
	RJMP _0x63
	SBRS R2,0
	RJMP _0x64
_0x63:
	RJMP _0x62
_0x64:
	LDI  R30,LOW(20)
	RJMP _0xD6
_0x62:
	LDS  R30,_min_l
_0xD6:
	STS  _tmp_1,R30
;     370         if (tmr_ind || set_hour || set_min) tmp_2 = 1; //  "" - 
	SBRC R2,3
	RJMP _0x67
	SBRC R2,4
	RJMP _0x67
	SBRS R2,5
	RJMP _0x66
_0x67:
	LDI  R30,LOW(1)
	STS  _tmp_2,R30
;     371         break;
_0x66:
	RJMP _0x60
;     372     case 1: if (set_min && ~bit_sec_1) tmp_1 = 20; else tmp_1 = min_h;
_0x61:
	CPI  R30,LOW(0x1)
	BRNE _0x69
	SBRS R2,5
	RJMP _0x6B
	SBRS R2,0
	RJMP _0x6C
_0x6B:
	RJMP _0x6A
_0x6C:
	LDI  R30,LOW(20)
	RJMP _0xD7
_0x6A:
	LDS  R30,_min_h
_0xD7:
	STS  _tmp_1,R30
;     373         if (pwr_on) tmp_2 = 1; //  
	SBRS R2,1
	RJMP _0x6E
	LDI  R30,LOW(1)
	STS  _tmp_2,R30
;     374         break;
_0x6E:
	RJMP _0x60
;     375     case 2: if (set_hour && ~bit_sec_1) tmp_1 = 20; else tmp_1 = hour_l;
_0x69:
	CPI  R30,LOW(0x2)
	BRNE _0x6F
	SBRS R2,4
	RJMP _0x71
	SBRS R2,0
	RJMP _0x72
_0x71:
	RJMP _0x70
_0x72:
	LDI  R30,LOW(20)
	RJMP _0xD8
_0x70:
	LDS  R30,_hour_l
_0xD8:
	STS  _tmp_1,R30
;     376         if (bit_sec_1) tmp_2 = 1; //     
	SBRS R2,0
	RJMP _0x74
	LDI  R30,LOW(1)
	STS  _tmp_2,R30
;     377         break;
_0x74:
	RJMP _0x60
;     378     case 3: if (set_hour && ~bit_sec_1) tmp_1 = 20; else tmp_1 = hour_h;
_0x6F:
	CPI  R30,LOW(0x3)
	BRNE _0x60
	SBRS R2,4
	RJMP _0x77
	SBRS R2,0
	RJMP _0x78
_0x77:
	RJMP _0x76
_0x78:
	LDI  R30,LOW(20)
	RJMP _0xD9
_0x76:
	LDS  R30,_hour_h
_0xD9:
	STS  _tmp_1,R30
;     379         if (tmr_on || snd_num > 0 && bit_sec_1) tmp_2 = 1; //       
	SBRC R2,2
	RJMP _0x7B
	LDS  R26,_snd_num
	CPI  R26,LOW(0x1)
	BRLO _0x7C
	SBRC R2,0
	RJMP _0x7B
_0x7C:
	RJMP _0x7A
_0x7B:
	LDI  R30,LOW(1)
	STS  _tmp_2,R30
;     380     } //switch (n4)
_0x7A:
_0x60:
;     381 reg164(1, 8, tmp_1, tmp_2);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x3
;     382 
;     383 //     
;     384 tmp_1 = adc_arr[n4];
	LDS  R30,_n4
	LDI  R31,0
	SUBI R30,LOW(-_adc_arr)
	SBCI R31,HIGH(-_adc_arr)
	LD   R30,Z
	STS  _tmp_1,R30
;     385 reg164(1, 8, tmp_1, 0);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDS  R30,_tmp_1
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _reg164
;     386 
;     387 // 
;     388 switch (n4)
	LDS  R30,_n4
;     389     {
;     390     case 0: PORTC.3 = 1; break;
	CPI  R30,0
	BRNE _0x82
	SBI  0x15,3
	RJMP _0x81
;     391     case 1: PORTC.2 = 1; break;
_0x82:
	CPI  R30,LOW(0x1)
	BRNE _0x85
	SBI  0x15,2
	RJMP _0x81
;     392     case 2: PORTC.1 = 1; break;
_0x85:
	CPI  R30,LOW(0x2)
	BRNE _0x88
	SBI  0x15,1
	RJMP _0x81
;     393     case 3: PORTC.0 = 1;
_0x88:
	CPI  R30,LOW(0x3)
	BRNE _0x81
	SBI  0x15,0
;     394     }
_0x81:
;     395 
;     396 delay_us(2);
	__DELAY_USB 8
;     397 
;     398 //  
;     399 switch (n4)
	LDS  R30,_n4
;     400     {
;     401     case 0: key_in = (~PINB & 0xC0) / 64; break;
	CPI  R30,0
	BRNE _0x91
	RCALL SUBOPT_0x4
	LDI  R31,0
	RCALL SUBOPT_0x5
	RJMP _0x90
;     402     case 1: key_in <<= 2; key_in = key_in + (~PINB & 0xC0) / 64; break;
_0x91:
	CPI  R30,LOW(0x1)
	BRNE _0x92
	RCALL SUBOPT_0x6
	CALL __LSLW2
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
	RJMP _0x90
;     403     case 2: key_in <<= 3; key_in = key_in + (~PINB & 0xE0) / 32; break;
_0x92:
	CPI  R30,LOW(0x2)
	BRNE _0x93
	RCALL SUBOPT_0x8
	RJMP _0x90
;     404     case 3: key_in <<= 3; key_in = key_in + (~PINB & 0xE0) / 32;
_0x93:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x90
	RCALL SUBOPT_0x8
;     405     if (key_in == 0)
	RCALL SUBOPT_0x6
	SBIW R30,0
	BREQ _0x96
;     406         goto new_key; //    
;     407     if (key_old != 0)
	LDS  R30,_key_old
	LDS  R31,_key_old+1
	SBIW R30,0
	BREQ _0x97
;     408         break; //    
	RJMP _0x90
;     409     if (count_key_released)
_0x97:
	LDS  R30,_count_key_released
	CPI  R30,0
	BREQ _0x98
;     410         -- count_key_released;
	SUBI R30,LOW(1)
	RJMP _0xDA
;     411     else
_0x98:
;     412         {
;     413         if (-- count_key_pressed == count_key_pressed_first - 1)
	LDS  R26,_count_key_pressed
	SUBI R26,LOW(1)
	STS  _count_key_pressed,R26
	LDI  R30,LOW(_count_key_pressed_first*2)
	LDI  R31,HIGH(_count_key_pressed_first*2)
	LPM  R30,Z
	SUBI R30,LOW(1)
	CP   R30,R26
	BRNE _0x9A
;     414             key_tmp = key_in;
	RCALL SUBOPT_0x6
	STS  _key_tmp,R30
	STS  _key_tmp+1,R31
;     415         else
	RJMP _0x9B
_0x9A:
;     416             {
;     417             if (key_tmp != key_in)
	RCALL SUBOPT_0x6
	LDS  R26,_key_tmp
	LDS  R27,_key_tmp+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x9C
;     418                 {
;     419 new_key:
_0x96:
;     420                 count_key_pressed = count_key_pressed_first;
	LDI  R30,LOW(_count_key_pressed_first*2)
	LDI  R31,HIGH(_count_key_pressed_first*2)
	LPM  R30,Z
	STS  _count_key_pressed,R30
;     421                 count_key_released = 0;
	LDI  R30,LOW(0)
	STS  _count_key_released,R30
;     422                 key_old = 0;
	LDI  R30,0
	STS  _key_old,R30
	STS  _key_old+1,R30
;     423                 key_ok = 0;
	LDI  R30,0
	STS  _key_ok,R30
	STS  _key_ok+1,R30
;     424                 goto end_key;
	RJMP _0x9D
;     425                 }
;     426             if (count_key_pressed == 0)
_0x9C:
	LDS  R30,_count_key_pressed
	CPI  R30,0
	BRNE _0x9E
;     427                 {
;     428                 key_ok = key_in;
	RCALL SUBOPT_0x6
	STS  _key_ok,R30
	STS  _key_ok+1,R31
;     429                 count_key_released = count_key_released_first;
	LDI  R30,LOW(_count_key_released_first*2)
	LDI  R31,HIGH(_count_key_released_first*2)
	LPM  R30,Z
_0xDA:
	STS  _count_key_released,R30
;     430                 }
;     431             } //if (-- count_key_pressed == count_key_pressed_first - 1)
_0x9E:
_0x9B:
;     432         } //if (count_key_released)
;     433 end_key:
_0x9D:
;     434     key_in = 0; //   /*  */
	LDI  R30,0
	STS  _key_in,R30
	STS  _key_in+1,R30
;     435 
;     436     //  
;     437     if (key_ok != 0)
	RCALL SUBOPT_0x9
	SBIW R30,0
	BRNE PC+3
	JMP _0x9F
;     438         {
;     439         if (snd_num == 0)
	LDS  R30,_snd_num
	CPI  R30,0
	BREQ PC+3
	JMP _0xA0
;     440             {
;     441             switch (key_ok)
	RCALL SUBOPT_0x9
;     442                 {
;     443                 case 1: err_5v = 1; err_12v = 0; break; // 1 "t -"
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xA4
	SET
	BLD  R2,6
	CLT
	BLD  R2,7
	RJMP _0xA3
;     444                 case 8: err_12v = 1; err_5v = 0; break; // 2 "t +"
_0xA4:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xA5
	SET
	BLD  R2,7
	CLT
	BLD  R2,6
	RJMP _0xA3
;     445                 case 9: err_12v = 0; err_5v = 0; break; // 1  2
_0xA5:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0xA6
	CLT
	BLD  R2,7
	BLD  R2,6
	RJMP _0xA3
;     446 
;     447                 case 16: tmr_ind = 1; tmr_time = tmr_time_first; break; // 4 ""
_0xA6:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0xA7
	SET
	BLD  R2,3
	RCALL SUBOPT_0xA
	RJMP _0xA3
;     448 
;     449                 case 320: // 5+6 ".."
_0xA7:
	CPI  R30,LOW(0x140)
	LDI  R26,HIGH(0x140)
	CPC  R31,R26
	BRNE _0xA8
;     450                     if (set_hour) {set_min = 1; set_hour = 0;} //    
	SBRS R2,4
	RJMP _0xA9
	SET
	BLD  R2,5
	CLT
	RJMP _0xDB
;     451                     else {set_min = 0; set_hour = 1;}
_0xA9:
	CLT
	BLD  R2,5
	SET
_0xDB:
	BLD  R2,4
;     452                     sec = 0; set_time = set_time_first;
	RCALL SUBOPT_0xB
;     453                     break;
	RJMP _0xA3
;     454 
;     455                 case 4: // 7 "-"
_0xA8:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xAB
;     456                     if (tmr_ind) {if (tmr_min > 0) tmr_min --; tmr_time = tmr_time_first;}
	SBRS R2,3
	RJMP _0xAC
	LDS  R26,_tmr_min
	CPI  R26,LOW(0x1)
	BRLO _0xAD
	LDS  R30,_tmr_min
	SUBI R30,LOW(1)
	STS  _tmr_min,R30
_0xAD:
	RCALL SUBOPT_0xA
;     457                     if (set_hour) {if (hour > 0) hour --; else hour = 23; sec = 0; set_time = set_time_first;}
_0xAC:
	SBRS R2,4
	RJMP _0xAE
	LDS  R26,_hour
	CPI  R26,LOW(0x1)
	BRLO _0xAF
	LDS  R30,_hour
	SUBI R30,LOW(1)
	RJMP _0xDC
_0xAF:
	LDI  R30,LOW(23)
_0xDC:
	STS  _hour,R30
	RCALL SUBOPT_0xB
;     458                     if (set_min) {if (min > 0) min --; else min = 59; sec = 0; set_time = set_time_first;}
_0xAE:
	SBRS R2,5
	RJMP _0xB1
	LDS  R26,_min
	CPI  R26,LOW(0x1)
	BRLO _0xB2
	LDS  R30,_min
	SUBI R30,LOW(1)
	RJMP _0xDD
_0xB2:
	LDI  R30,LOW(59)
_0xDD:
	STS  _min,R30
	RCALL SUBOPT_0xB
;     459                     break;
_0xB1:
	RJMP _0xA3
;     460                 case 32: // 8 "+"
_0xAB:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0xB4
;     461                     if (tmr_ind) {if (tmr_min < 59) tmr_min ++; tmr_time = tmr_time_first;}
	SBRS R2,3
	RJMP _0xB5
	LDS  R26,_tmr_min
	CPI  R26,LOW(0x3B)
	BRSH _0xB6
	LDS  R30,_tmr_min
	SUBI R30,-LOW(1)
	STS  _tmr_min,R30
_0xB6:
	RCALL SUBOPT_0xA
;     462                     if (set_hour) {if (hour < 23) hour ++; else hour = 0; sec = 0; set_time = set_time_first;}
_0xB5:
	SBRS R2,4
	RJMP _0xB7
	LDS  R26,_hour
	CPI  R26,LOW(0x17)
	BRSH _0xB8
	LDS  R30,_hour
	SUBI R30,-LOW(1)
	RJMP _0xDE
_0xB8:
	LDI  R30,LOW(0)
_0xDE:
	STS  _hour,R30
	RCALL SUBOPT_0xB
;     463                     if (set_min) {if (min < 59) min ++; else min = 0; sec = 0; set_time = set_time_first;}
_0xB7:
	SBRS R2,5
	RJMP _0xBA
	LDS  R26,_min
	CPI  R26,LOW(0x3B)
	BRSH _0xBB
	LDS  R30,_min
	SUBI R30,-LOW(1)
	RJMP _0xDF
_0xBB:
	LDI  R30,LOW(0)
_0xDF:
	STS  _min,R30
	RCALL SUBOPT_0xB
;     464                     break;
_0xBA:
	RJMP _0xA3
;     465 
;     466                 case 2: pwr_on = ~pwr_on; // 3 "on/off"
_0xB4:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xBD
	LDI  R30,LOW(2)
	EOR  R2,R30
;     467                     if (pwr_on) {pwr_mod = 512; pwr_time = pwr_time_first;}
	SBRS R2,1
	RJMP _0xBE
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	MOVW R10,R30
	LDI  R30,LOW(_pwr_time_first*2)
	LDI  R31,HIGH(_pwr_time_first*2)
	LPM  R30,Z
	RJMP _0xE0
;     468                     else {pwr_mod = 0; pwr_time = 20;} // ,      
_0xBE:
	CLR  R10
	CLR  R11
	LDI  R30,LOW(20)
_0xE0:
	STS  _pwr_time,R30
;     469                     break;
	RJMP _0xA3
;     470                 case 128: // 9 " "
_0xBD:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0xC0
;     471                     if (pwr_mod == 512) pwr_mod = 1;
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R30,R10
	CPC  R31,R11
	BRNE _0xC1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	MOVW R10,R30
;     472                     else pwr_mod <<= 1;
	RJMP _0xC2
_0xC1:
	LSL  R10
	ROL  R11
;     473                     pwr_time = pwr_time_first;
_0xC2:
	RJMP _0xE1
;     474                     break;
;     475                 case 512: // 10 " "
_0xC0:
	CPI  R30,LOW(0x200)
	LDI  R26,HIGH(0x200)
	CPC  R31,R26
	BRNE _0xA3
;     476                     if (pwr_mod == 1) pwr_mod = 512;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R10
	CPC  R31,R11
	BRNE _0xC4
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	MOVW R10,R30
;     477                     else pwr_mod >>= 1;
	RJMP _0xC5
_0xC4:
	LSR  R11
	ROR  R10
;     478                     pwr_time = pwr_time_first;
_0xC5:
_0xE1:
	LDI  R30,LOW(_pwr_time_first*2)
	LDI  R31,HIGH(_pwr_time_first*2)
	LPM  R30,Z
	STS  _pwr_time,R30
;     479                     break;
;     480                 } //switch (key_ok)
_0xA3:
;     481             key_old = key_ok;
	RCALL SUBOPT_0xC
;     482             snd_time = snd_time_key; //  
	LDI  R30,LOW(_snd_time_key*2)
	LDI  R31,HIGH(_snd_time_key*2)
	LPM  R30,Z
	STS  _snd_time,R30
;     483             }
;     484         else
	RJMP _0xC6
_0xA0:
;     485             {
;     486             snd_num = 0; //    ,  
	LDI  R30,LOW(0)
	STS  _snd_num,R30
;     487             key_old = key_ok;
	RCALL SUBOPT_0xC
;     488             } //if (snd_num == 0)
_0xC6:
;     489         } //if (key_ok != 0)
;     490     } //switch (n4)
_0x9F:
_0x90:
;     491 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     492 
;     493 
;     494 
;     495 /******************     ******************/
;     496 
;     497 
;     498 
;     499 void main(void)
;     500 {
_main:
;     501 // Declare your local variables here
;     502 
;     503 // Input/Output Ports initialization
;     504 // Port A initialization
;     505 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     506 // State7=P State6=P State5=P State4=P State3=P State2=T State1=T State0=T
;     507 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;     508 PORTA=0xF8;
	LDI  R30,LOW(248)
	OUT  0x1B,R30
;     509 
;     510 // Port B initialization
;     511 // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     512 // State7=P State6=P State5=P State4=0 State3=0 State2=0 State1=0 State0=0
;     513 DDRB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x17,R30
;     514 PORTB=0xE0;
	LDI  R30,LOW(224)
	OUT  0x18,R30
;     515 
;     516 // Port C initialization
;     517 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     518 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     519 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     520 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     521 
;     522 // Port D initialization
;     523 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=Out
;     524 // State7=0 State6=0 State5=0 State4=0 State3=P State2=0 State1=0 State0=0
;     525 DDRD=0xF7;
	LDI  R30,LOW(247)
	OUT  0x11,R30
;     526 PORTD=0x08;
	LDI  R30,LOW(8)
	OUT  0x12,R30
;     527 
;     528 // Timer/Counter 0 initialization - 375   ..  
;     529 // Clock source: System Clock
;     530 // Clock value: 46.875 kHz
;     531 // Mode: CTC top=OCR0
;     532 // OC0 output: Disconnected
;     533 TCCR0=0x0C;
	LDI  R30,LOW(12)
	OUT  0x33,R30
;     534 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     535 OCR0=0x7D;
	LDI  R30,LOW(125)
	OUT  0x3C,R30
;     536 
;     537 // Timer/Counter 1 initialization -  
;     538 // Clock source: System Clock
;     539 // Clock value: 1500.000 kHz
;     540 // Mode: CTC top=OCR1A
;     541 // OC1A output: Discon.
;     542 // OC1B output: Discon.
;     543 // Noise Canceler: Off
;     544 // Input Capture on Falling Edge
;     545 // Timer 1 Overflow Interrupt: Off
;     546 // Input Capture Interrupt: Off
;     547 // Compare A Match Interrupt: On
;     548 // Compare B Match Interrupt: Off
;     549 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;     550 TCCR1B=0x0A;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
;     551 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     552 TCNT1L=0x00;
	OUT  0x2C,R30
;     553 ICR1H=0x00;
	OUT  0x27,R30
;     554 ICR1L=0x00;
	OUT  0x26,R30
;     555 OCR1AH=0x02;
	LDI  R30,LOW(2)
	OUT  0x2B,R30
;     556 OCR1AL=0x00;
	LDI  R30,LOW(0)
	OUT  0x2A,R30
;     557 OCR1BH=0x00;
	OUT  0x29,R30
;     558 OCR1BL=0x00;
	OUT  0x28,R30
;     559 
;     560 // Timer/Counter 2 initialization
;     561 // Clock source: System Clock
;     562 // Clock value: Timer 2 Stopped
;     563 // Mode: Normal top=FFh
;     564 // OC2 output: Disconnected
;     565 ASSR=0x00;
	OUT  0x22,R30
;     566 TCCR2=0x00;
	OUT  0x25,R30
;     567 TCNT2=0x00;
	OUT  0x24,R30
;     568 OCR2=0x00;
	OUT  0x23,R30
;     569 
;     570 // External Interrupt(s) initialization
;     571 // INT0: Off
;     572 // INT1: On -     .
;     573 // INT1 Mode: Rising Edge
;     574 // INT2: Off
;     575 GICR|=0x80;
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
;     576 MCUCR=0x0C;
	LDI  R30,LOW(12)
	OUT  0x35,R30
;     577 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
;     578 GIFR=0x80;
	LDI  R30,LOW(128)
	OUT  0x3A,R30
;     579 
;     580 // Timer(s)/Counter(s) Interrupt(s) initialization
;     581 TIMSK=0x12;
	LDI  R30,LOW(18)
	OUT  0x39,R30
;     582 
;     583 // Analog Comparator initialization
;     584 // Analog Comparator: Off
;     585 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     586 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     587 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     588 
;     589 // ADC initialization
;     590 // ADC Clock frequency: 93.750 kHz
;     591 // ADC Voltage Reference: AREF pin
;     592 // ADC Auto Trigger Source: None
;     593 ADMUX=ADC_VREF_TYPE & 0xff;
	OUT  0x7,R30
;     594 ADCSRA=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
;     595 
;     596 // Global enable interrupts
;     597 #asm("sei")
	sei
;     598 
;     599 while (1)
_0xC7:
;     600       {
;     601       // Place your code here
;     602 
;     603       };
	RJMP _0xC7
;     604 }
_0xCA:
	RJMP _0xCA


;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x0:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	CALL __DIVW21U
	ST   Y,R30
	STD  Y+1,R31
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	STS  _tmp_2,R30
	LDS  R30,_n4
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	ST   -Y,R30
	LDS  R30,_tmp_1
	ST   -Y,R30
	LDS  R30,_tmp_2
	ST   -Y,R30
	RJMP _reg164

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	IN   R30,0x16
	COM  R30
	ANDI R30,LOW(0xC0)
	LSR  R30
	LSR  R30
	SWAP R30
	ANDI R30,0xF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5:
	STS  _key_in,R30
	STS  _key_in+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6:
	LDS  R30,_key_in
	LDS  R31,_key_in+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x7:
	LDS  R26,_key_in
	LDS  R27,_key_in+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8:
	RCALL SUBOPT_0x6
	CALL __LSLW3
	RCALL SUBOPT_0x5
	IN   R30,0x16
	COM  R30
	ANDI R30,LOW(0xE0)
	LSR  R30
	SWAP R30
	ANDI R30,0xF
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDS  R30,_key_ok
	LDS  R31,_key_ok+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(_tmr_time_first*2)
	LDI  R31,HIGH(_tmr_time_first*2)
	LPM  R30,Z
	STS  _tmr_time,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(0)
	STS  _sec,R30
	LDI  R30,LOW(_set_time_first*2)
	LDI  R31,HIGH(_set_time_first*2)
	LPM  R30,Z
	STS  _set_time,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0x9
	STS  _key_old,R30
	STS  _key_old+1,R31
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

;END OF CODE MARKER
__END_OF_CODE:
