/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : kaiser
Version :
Date    : 26.01.2010
Author  : noname
Company : none
Comments:


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 12.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

#include <delay.h>
//#include <math.h>

#define ADC_VREF_TYPE 0x00


const unsigned char ind_arr[21] = {   // 
    0xFC, 0x60, 0xDA, 0xF2, 0x66, 0xB6, 0xBE, 0xE0, 0xFE, 0xF6, //0123456789
    0x02, 0xC6, 0x9E, 0x8E, 0x2A, 0x0A, 0x7A, 0x6E, 0x0C, 0x1E, //-EFnrdHIt
    0x00 //
    };

const unsigned char tmr_time_first = 100; //      
const unsigned char pwr_time_first = 100; //      
const unsigned char set_time_first = 100; //      
const unsigned char snd_time_key = 3;     //   
const unsigned char snd_time_tmr = 10;     //  
const unsigned char count_key_pressed_first = 10; //    
const unsigned char count_key_released_first = 20; //    

bit bit_sec_1; //1 -     , 0 - 
bit pwr_on; //1 -  , 0 - 
bit tmr_on; //1 -  , 0 - 
bit tmr_ind; //1 -   
bit set_hour; //1 -   
bit set_min; //1 -   
bit err_5v, err_12v; //1 -    ( )

unsigned int adc_0, adc_1, adc_2; //  ADC - ,  5  12
unsigned int pwr_mod; //  , 0 - 
unsigned int pwr_rly; //  
unsigned int key_in, key_tmp, key_ok, key_old; //    
unsigned char count_key_pressed, count_key_released; //  
unsigned char tmr_time; //   
unsigned char pwr_time; //     
unsigned char set_time; //   
unsigned char snd_time; //   
unsigned char snd_num; //   
unsigned char tmp_1, tmp_2; //temporary
unsigned char n25, n15; //   1
unsigned char n4 = 3; //    , 0 -  
unsigned char hour, min, sec; //   
unsigned char hsec; //   
unsigned char tmr_min, tmr_sec; ////  
unsigned char hour_h, hour_l, min_h, min_l; //   

unsigned char adc_arr[4] = {16, 16, 18, 17};  //   


/******************    ******************/



// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}



//      164
void reg164(unsigned char rezh, unsigned char xx, unsigned char simb, unsigned char dp)
{
unsigned char x;
if (rezh) simb = ind_arr[simb] + dp; // rezh=1    ,   
for (x = 0; x < xx; x ++) // 
    {
    PORTC.6 = simb % 2;
    simb >>= 1;
    PORTC.5 = 1;
    delay_us(1);
    PORTC.5 = 0;
    }
}



//  2-10  ADC
void _2_10(unsigned int xx)
{
adc_arr[0] = xx % 10;
xx = xx / 10;
adc_arr[1] = xx % 10;
xx = xx / 10;
adc_arr[2] = xx % 10;
adc_arr[3] = xx / 10;
}



//    
void pwr_pp(void)
{
if (pwr_time == 0) return;
if (pwr_time == 1)
    {
    PORTB.4 = 1;         //  
    switch (pwr_mod)     // 
        {
        case 1: pwr_rly = 80; break;
        case 2: pwr_rly = 102; break;
        case 4: pwr_rly = 34; break;
        case 8: pwr_rly = 38; break;
        case 16: pwr_rly = 67; break;
        case 32: pwr_rly = 81; break;
        case 64: pwr_rly = 80; break;
        case 128: pwr_rly = 3; break;
        case 256: pwr_rly = 1; break;
        case 512: pwr_rly = 128; break;
        default: pwr_rly = 0; PORTB.4 = 0; // ,  
            snd_time = snd_time_tmr;       //   
        }
    pwr_time = 0;
    PORTD = pwr_rly;     //  
    }
else pwr_time --;
}



//   
void tmr_pp(void)
{
if (tmr_time == 0) return;
if (tmr_time == 1)
    {
    if (tmr_min > 0) tmr_on = 1; //    ,   
    tmr_ind = 0;
    tmr_sec = 0;
    tmr_time = 0;
    }
else tmr_time --;
}



//   ..
void set_pp(void)
{
if (set_time == 0) return;
if (set_time == 1)
    {
    set_time = 0;
    set_hour = 0;
    set_min = 0;
    }
else set_time --;
}



//   
void snd_pp(void)
{
if (snd_time == 0) return;
if (snd_time == 1)
    {
    snd_time = 0;
    if (snd_num > 0) snd_num --; //   ,   
    PORTB.0 = 0;
    }
else snd_time --;
}



/******************    ******************/



// External Interrupt 1 service routine -     .
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// Place your code here

}



// Timer 1 output compare A interrupt service routine -  
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here
if (snd_time == 0) return;  //     
PORTB.0 = ~PORTB.0;
}



// Timer 0 output compare interrupt service routine - 375   ..  
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
//   ,   164
PORTC = 0;
delay_us(1);
PORTC.4 = 1;
if (hsec > 62)  //  375  !!!!!   . 4, -   125
    bit_sec_1 = 0;   // 1 
else
    hsec ++;

adc_0 = read_adc(0); //  
adc_1 = read_adc(1);

//  - 1525=375  !!!!!   . 4, - 525=125
if (n15 < 4)  //14
    n15 ++;
else
    {
    n15 = 0;
    pwr_pp(); //  
    tmr_pp(); //  
    set_pp(); //  ..
    snd_pp(); // 
    if (n25 < 24)
        {
        n25 ++;
        adc_2 = adc_2 + read_adc(2);  //  2  ADC - 
        }
    else
        {
        n25 = 0;
        bit_sec_1 = 1; // 1   
        hsec = 0;

        //2  ADC
        adc_2 = adc_2 / 24;  //    24  \
        if (err_5v)          //   
            _2_10(adc_0);    //  
        else
            if (err_12v)
                _2_10(adc_1);
            else
                _2_10(adc_2);
        adc_2 = 0;

        //
        if (sec < 59)
            sec ++;
        else
            {
            if (min < 59)
                min ++;
            else
                {
                if (hour < 23)
                    hour ++;
                else
                    hour = 0;
                min = 0;
                }
            sec = 0;
            }

        //
        if (tmr_on && ~tmr_ind)
            {
            if (tmr_sec < 59)
                tmr_sec ++;
            else
                {
                if (tmr_min > 1)
                    tmr_min --;
                else
                    {
                    tmr_on = 0;
                    tmr_min = 0;
                    snd_num = 60; // 60  
                    }
                tmr_sec = 0;
                }
            }

        //  
        if (snd_num > 0)
            {
            snd_time = snd_time_tmr;
            }

        //   
        if (tmr_ind)
            {
            min_l = tmr_min % 10;
            min_h = tmr_min / 10;
            hour_l = 20;//  
            hour_h = 20; //20 -  ""
            }
        else
            {
            min_l = min % 10;
            min_h = min / 10;
            hour_l = hour % 10;
            if (hour > 9) //  
                hour_h = hour / 10;
            else
                hour_h = 20; //20 -  ""
            }
        } //if (n25 < 24)
    }//if (n15 < 14)   - 1525=375

//  
if (n4 < 3)
    n4 ++;
else
    n4 = 0;


//    
tmp_2 = 0;
switch (n4)
    {
    case 0: tmp_1 = pwr_mod; break;
    case 1: tmp_1 = pwr_mod >> 5; break;
    case 2: tmp_1 = pwr_mod; break;
    case 3: tmp_1 = pwr_mod >> 5;
    }
reg164(0, 5, tmp_1, tmp_2);


//     
tmp_2 = 0;
switch (n4)
    {
    case 0: if (set_min && ~bit_sec_1) tmp_1 = 20; else tmp_1 = min_l; //    ..
        if (tmr_ind || set_hour || set_min) tmp_2 = 1; //  "" - 
        break;
    case 1: if (set_min && ~bit_sec_1) tmp_1 = 20; else tmp_1 = min_h;
        if (pwr_on) tmp_2 = 1; //  
        break;
    case 2: if (set_hour && ~bit_sec_1) tmp_1 = 20; else tmp_1 = hour_l;
        if (bit_sec_1) tmp_2 = 1; //     
        break;
    case 3: if (set_hour && ~bit_sec_1) tmp_1 = 20; else tmp_1 = hour_h;
        if (tmr_on || snd_num > 0 && bit_sec_1) tmp_2 = 1; //       
    } //switch (n4)
reg164(1, 8, tmp_1, tmp_2);

//     
tmp_1 = adc_arr[n4];
reg164(1, 8, tmp_1, 0);

// 
switch (n4)
    {
    case 0: PORTC.3 = 1; break;
    case 1: PORTC.2 = 1; break;
    case 2: PORTC.1 = 1; break;
    case 3: PORTC.0 = 1;
    }

delay_us(2);

//  
switch (n4)
    {
    case 0: key_in = (~PINB & 0xC0) / 64; break;
    case 1: key_in <<= 2; key_in = key_in + (~PINB & 0xC0) / 64; break;
    case 2: key_in <<= 3; key_in = key_in + (~PINB & 0xE0) / 32; break;
    case 3: key_in <<= 3; key_in = key_in + (~PINB & 0xE0) / 32;
    if (key_in == 0)
        goto new_key; //    
    if (key_old != 0)
        break; //    
    if (count_key_released)
        -- count_key_released;
    else
        {
        if (-- count_key_pressed == count_key_pressed_first - 1)
            key_tmp = key_in;
        else
            {
            if (key_tmp != key_in)
                {
new_key:
                count_key_pressed = count_key_pressed_first;
                count_key_released = 0;
                key_old = 0;
                key_ok = 0;
                goto end_key;
                }
            if (count_key_pressed == 0)
                {
                key_ok = key_in;
                count_key_released = count_key_released_first;
                }
            } //if (-- count_key_pressed == count_key_pressed_first - 1)
        } //if (count_key_released)
end_key:
    key_in = 0; //   /*  */

    //  
    if (key_ok != 0)
        {
        if (snd_num == 0)
            {
            switch (key_ok)
                {
                case 1: err_5v = 1; err_12v = 0; break; // 1 "t -"
                case 8: err_12v = 1; err_5v = 0; break; // 2 "t +"
                case 9: err_12v = 0; err_5v = 0; break; // 1  2

                case 16: tmr_ind = 1; tmr_time = tmr_time_first; break; // 4 ""

                case 320: // 5+6 ".."
                    if (set_hour) {set_min = 1; set_hour = 0;} //    
                    else {set_min = 0; set_hour = 1;}
                    sec = 0; set_time = set_time_first;
                    break;

                case 4: // 7 "-"
                    if (tmr_ind) {if (tmr_min > 0) tmr_min --; tmr_time = tmr_time_first;}
                    if (set_hour) {if (hour > 0) hour --; else hour = 23; sec = 0; set_time = set_time_first;}
                    if (set_min) {if (min > 0) min --; else min = 59; sec = 0; set_time = set_time_first;}
                    break;
                case 32: // 8 "+"
                    if (tmr_ind) {if (tmr_min < 59) tmr_min ++; tmr_time = tmr_time_first;}
                    if (set_hour) {if (hour < 23) hour ++; else hour = 0; sec = 0; set_time = set_time_first;}
                    if (set_min) {if (min < 59) min ++; else min = 0; sec = 0; set_time = set_time_first;}
                    break;

                case 2: pwr_on = ~pwr_on; // 3 "on/off"
                    if (pwr_on) {pwr_mod = 512; pwr_time = pwr_time_first;}
                    else {pwr_mod = 0; pwr_time = 20;} // ,      
                    break;
                case 128: // 9 " "
                    if (pwr_mod == 512) pwr_mod = 1;
                    else pwr_mod <<= 1;
                    pwr_time = pwr_time_first;
                    break;
                case 512: // 10 " "
                    if (pwr_mod == 1) pwr_mod = 512;
                    else pwr_mod >>= 1;
                    pwr_time = pwr_time_first;
                    break;
                } //switch (key_ok)
            key_old = key_ok;
            snd_time = snd_time_key; //  
            }
        else
            {
            snd_num = 0; //    ,  
            key_old = key_ok;
            } //if (snd_num == 0)
        } //if (key_ok != 0)
    } //switch (n4)
}



/******************     ******************/



void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=P State6=P State5=P State4=P State3=P State2=T State1=T State0=T
DDRA=0x00;
PORTA=0xF8;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=P State6=P State5=P State4=0 State3=0 State2=0 State1=0 State0=0
DDRB=0x1F;
PORTB=0xE0;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
DDRC=0xFF;
PORTC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=Out
// State7=0 State6=0 State5=0 State4=0 State3=P State2=0 State1=0 State0=0
DDRD=0xF7;
PORTD=0x08;

// Timer/Counter 0 initialization - 375   ..  
// Clock source: System Clock
// Clock value: 46.875 kHz
// Mode: CTC top=OCR0
// OC0 output: Disconnected
TCCR0=0x0C;
TCNT0=0x00;
OCR0=0x7D;

// Timer/Counter 1 initialization -  
// Clock source: System Clock
// Clock value: 1500.000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x02;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On -     .
// INT1 Mode: Rising Edge
// INT2: Off
GICR|=0x80;
MCUCR=0x0C;
MCUCSR=0x00;
GIFR=0x80;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x12;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 93.750 kHz
// ADC Voltage Reference: AREF pin
// ADC Auto Trigger Source: None
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x87;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here

      };
}
